package cn.wisenergy.mapper;

import cn.wisenergy.model.app.ProgressPrize;
import cn.wisenergy.model.vo.ProgressPrizeVo;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * @author 86187
 */
public interface ProgressPrizeMapper extends BaseMapper<ProgressPrize> {

    int add(ProgressPrize progressPrize);

    int edit(ProgressPrize progressPrize);

    int delById(@Param("id") Integer id);

    /**
     * 根据 年月 获取月的最大进步奖用户列表
     *
     * @param yearMonth 年月
     * @return 最大进步奖用户列表
     */
    List<ProgressPrize> getByYearMonth(@Param("yearMonth") String yearMonth);


    /**
     * 获取本月月的最大进步奖用户列表 倒序 增长率相等的，按注册时间倒序
     *
     * @param yearMonth 年月
     * @return 最大进步奖用户列表
     */
    List<ProgressPrizeVo> getByTime(@Param("yearMonth") String yearMonth);

    /**
     * 根据 userId 年月 获取月的最大进步奖用户
     * @param userId 用户id
     * @param yearMonth 年月
     * @return 最大进步奖用户列表
     */
    ProgressPrize getByUserIdYearMonth(@Param("userId") String userId,@Param("yearMonth") String yearMonth);


    /**
     * 统计最大进步奖总记录数
     *
     * @param map 入参
     * @return 结果
     */
    int count( Map<String, Object> map);

    /**
     * 获取最大进步奖列表
     * @param map 入参
     * @return 结果集
     */
    List<ProgressPrize> getList(Map<String, Object> map);
}
